 SUBROUTINE data_log( array, i1, i2, j1, j2, k1, k2 )

!------------------------------------------------------------------------------!
! Actual revisions:
! -----------------
! 
!
! Former revisions:
! -----------------
! $Id: data_log.f90 4 2007-02-13 11:33:16Z raasch $
! RCS Log replace by Id keyword, revision history cleaned up
!
! Revision 1.1  2006/02/23 10:09:29  raasch
! Initial revision
!
!
! Description:
! ------------
! Complete logging of data
!------------------------------------------------------------------------------!
#if defined( __logging )

    USE control_parameters
    USE pegrid

    IMPLICIT NONE

    INTEGER ::  i1, i2, j1, j2, k1, k2

    REAL, DIMENSION(i1:i2,j1:j2,k1:k2) ::  array


!
!-- Open the file for data logging
    CALL check_open( 20 )

!
!-- Write the message string
    WRITE ( 20 )  log_message

!
!-- Write the simulated time and the array indices
    WRITE ( 20 )  simulated_time, i1, i2, j1, j2, k1, k2

!
!-- Write the array
    WRITE ( 20 )  array

#endif
 END SUBROUTINE data_log



 SUBROUTINE data_log_2d( array, i1, i2, j1, j2)

!------------------------------------------------------------------------------!
! Description:
! ------------
! Same as above, for 2d arrays
!------------------------------------------------------------------------------!
#if defined( __logging )

    USE control_parameters
    USE pegrid

    IMPLICIT NONE

    INTEGER ::  i1, i2, j1, j2

    REAL, DIMENSION(i1:i2,j1:j2) ::  array


!
!-- Open the file for data logging
    CALL check_open( 20 )

!
!-- Write the message string
    WRITE ( 20 )  log_message

!
!-- Write the simulated time and the array indices
    WRITE ( 20 )  simulated_time, i1, i2, j1, j2

!
!-- Write the array
    WRITE ( 20 )  array

#endif
 END SUBROUTINE data_log_2d



 SUBROUTINE data_log_2d_int( array, i1, i2, j1, j2)

!------------------------------------------------------------------------------!
! Description:
! ------------
! Same as above, for 2d integer arrays
!------------------------------------------------------------------------------!
#if defined( __logging )

    USE control_parameters
    USE pegrid

    IMPLICIT NONE

    INTEGER ::  i1, i2, j1, j2

    INTEGER, DIMENSION(i1:i2,j1:j2) ::  array


!
!-- Open the file for data logging
    CALL check_open( 20 )

!
!-- Write the message string
    WRITE ( 20 )  log_message

!
!-- Write the simulated time and the array indices
    WRITE ( 20 )  simulated_time, i1, i2, j1, j2

!
!-- Write the array
    WRITE ( 20 )  array

#endif
 END SUBROUTINE data_log_2d_int
